package com.app.kemenhub.jakbanapps.db;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import de.greenrobot.dao.AbstractDao;
import de.greenrobot.dao.Property;
import de.greenrobot.dao.internal.DaoConfig;

import com.app.kemenhub.jakbanapps.db.taxi_fee;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "TAXI_FEE".
*/
public class taxi_feeDao extends AbstractDao<taxi_fee, Long> {

    public static final String TABLENAME = "TAXI_FEE";

    /**
     * Properties of entity taxi_fee.<br/>
     * Can be used for QueryBuilder and for referencing column names.
    */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "id", true, "_id");
        public final static Property Provinsi_id = new Property(1, String.class, "provinsi_id", false, "PROVINSI_ID");
        public final static Property Unit = new Property(2, String.class, "unit", false, "UNIT");
        public final static Property Fee = new Property(3, String.class, "fee", false, "FEE");
    };


    public taxi_feeDao(DaoConfig config) {
        super(config);
    }
    
    public taxi_feeDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(SQLiteDatabase db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"TAXI_FEE\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: id
                "\"PROVINSI_ID\" TEXT," + // 1: provinsi_id
                "\"UNIT\" TEXT," + // 2: unit
                "\"FEE\" TEXT);"); // 3: fee
    }

    /** Drops the underlying database table. */
    public static void dropTable(SQLiteDatabase db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"TAXI_FEE\"";
        db.execSQL(sql);
    }

    /** @inheritdoc */
    @Override
    protected void bindValues(SQLiteStatement stmt, taxi_fee entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
 
        String provinsi_id = entity.getProvinsi_id();
        if (provinsi_id != null) {
            stmt.bindString(2, provinsi_id);
        }
 
        String unit = entity.getUnit();
        if (unit != null) {
            stmt.bindString(3, unit);
        }
 
        String fee = entity.getFee();
        if (fee != null) {
            stmt.bindString(4, fee);
        }
    }

    /** @inheritdoc */
    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    /** @inheritdoc */
    @Override
    public taxi_fee readEntity(Cursor cursor, int offset) {
        taxi_fee entity = new taxi_fee( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // id
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // provinsi_id
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2), // unit
            cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3) // fee
        );
        return entity;
    }
     
    /** @inheritdoc */
    @Override
    public void readEntity(Cursor cursor, taxi_fee entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setProvinsi_id(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setUnit(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
        entity.setFee(cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3));
     }
    
    /** @inheritdoc */
    @Override
    protected Long updateKeyAfterInsert(taxi_fee entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    /** @inheritdoc */
    @Override
    public Long getKey(taxi_fee entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    /** @inheritdoc */
    @Override    
    protected boolean isEntityUpdateable() {
        return true;
    }
    
}
